# errno.h

The errno.h header file supports an error-reporting mechanism. This mechanism provides an external static **memory** location (ERRNO).

Some library functions place a value in this memory location to report an error. A program, or functions in this *header* file, can check the value of ERRNO.

NOTE: ERRNO error reporting is less than **HIGH TECH**!

```c
//////////example errno values/////////////////


FILE * missingFile = fopen(“Z:\\Missing.txt”, “r”);
// errno == ENOENT == 2 /* No such file or directory */

char * missingPointer = malloc(9999999999999999999);
// errno == ENOMEM == 12 /* Out of memory */

FILE * lockedFile = fopen(“C:\\Windows\\Notepad.exe”, “w”);
// errno == EACCESS == 13 /* Permission denied */

FILE * badFileName = fopen(“C:\\Temp\\!@#$%^&*.txt”, “w+”);
// errno == EINVAL == 22 /* Invalid argument */

float imaginaryNumber = sqrt(-1);
// errno == EDOM == 33 /* Math argument out of domain of func */

///////////errno-related uses//////////////////

int feof(FILE *stream)
// Tests the end-of-file indicator for “stream”, non-0 if set

int ferror(FILE *stream)
// Tests the error indicator for the “stream”, non-0 if set 

void clearerr(FILE *stream)
// Clears the end-of-file and error indicators for “stream”

void perror(const char *s)
// Print a system error message to standard error

return <n>
// Specify <n> as the errno to provide the nature of error

char *strerror(int errnum)
// Returns a string describing the error number
```

When checking *errno*, make an immediate copy

Different error numbers may come and go durning the execution of your code.(this is normal)

```c
/////////////////////PRO-TIP////////////////////////

if (myFunc() == -1)			// -1 typically an error
{
    currentErrno = errno;		// Save errno
    printf(“myFunc() failed!”);	// Provide feedback
}

////////////// COMMON MISTAKE /////////////////////

if (myFunc() == -1) 			// -1 typically an error
{
    printf(“myFunc() failed!”);	// printf() may update errno
    currentErrno = errno;		// Errno wasn’t preserved
}
---

### PERFORMANCE LAB - ERRNO
